/*
 * Copyright 2006 Takahiro Nakamura.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package woolpack.misc;

import woolpack.fn.Fn;

public class FnRunnable<C> implements Runnable {
	private Fn<? super C, ?, ? extends RuntimeException> fn;
	private C c;
	
	public FnRunnable(final Fn<? super C, ?, ? extends RuntimeException> fn, final C c) {
		this.fn = fn;
		this.c = c;
	}

	public void run() {
		fn.exec(c);
	}

	public Fn<? super C, ?, ? extends RuntimeException> getFn() {
		return fn;
	}
	public void setFn(final Fn<? super C, ?, ? extends RuntimeException> fn) {
		this.fn = fn;
	}
	public C getC() {
		return c;
	}
	public void setC(final C c) {
		this.c = c;
	}
}
